package workloadforecast

class User {
	Role role
	int userId = 101
	String userName
	String firstName
	String lastName
	String password
	String gender = 'F'
	String emailAddress
	Date createdAt = new Date()
	String toString(){"${this.userName}"}
	static belongTo = Role
	static optionals = ["emailAddress"]

    static constraints = {
		userName(maxLength:15, blank:false)
		firstName(maxLength:20, blank:false)
		lastName(maxLength:20, blank:false)
		password(size:5..15,balnk:false, password:true)
		emailAddress(email:true)
		gender(inList:["F", "M"], blank:false)
		userId(min:101,max:999)
		createdAt(validator: {return (it > new Date())})
    }
}
