package workloadforecast



import org.junit.*
import grails.test.mixin.*

@TestFor(ActivityForecastController)
@Mock(ActivityForecast)
class ActivityForecastControllerTests {

    def populateValidParams(params) {
        assert params != null
        // TODO: Populate valid properties like...
        //params["name"] = 'someValidName'
    }

    void testIndex() {
        controller.index()
        assert "/activityForecast/list" == response.redirectedUrl
    }

    void testList() {

        def model = controller.list()

        assert model.activityForecastInstanceList.size() == 0
        assert model.activityForecastInstanceTotal == 0
    }

    void testCreate() {
        def model = controller.create()

        assert model.activityForecastInstance != null
    }

    void testSave() {
        controller.save()

        assert model.activityForecastInstance != null
        assert view == '/activityForecast/create'

        response.reset()

        populateValidParams(params)
        controller.save()

        assert response.redirectedUrl == '/activityForecast/show/1'
        assert controller.flash.message != null
        assert ActivityForecast.count() == 1
    }

    void testShow() {
        controller.show()

        assert flash.message != null
        assert response.redirectedUrl == '/activityForecast/list'

        populateValidParams(params)
        def activityForecast = new ActivityForecast(params)

        assert activityForecast.save() != null

        params.id = activityForecast.id

        def model = controller.show()

        assert model.activityForecastInstance == activityForecast
    }

    void testEdit() {
        controller.edit()

        assert flash.message != null
        assert response.redirectedUrl == '/activityForecast/list'

        populateValidParams(params)
        def activityForecast = new ActivityForecast(params)

        assert activityForecast.save() != null

        params.id = activityForecast.id

        def model = controller.edit()

        assert model.activityForecastInstance == activityForecast
    }

    void testUpdate() {
        controller.update()

        assert flash.message != null
        assert response.redirectedUrl == '/activityForecast/list'

        response.reset()

        populateValidParams(params)
        def activityForecast = new ActivityForecast(params)

        assert activityForecast.save() != null

        // test invalid parameters in update
        params.id = activityForecast.id
        //TODO: add invalid values to params object

        controller.update()

        assert view == "/activityForecast/edit"
        assert model.activityForecastInstance != null

        activityForecast.clearErrors()

        populateValidParams(params)
        controller.update()

        assert response.redirectedUrl == "/activityForecast/show/$activityForecast.id"
        assert flash.message != null

        //test outdated version number
        response.reset()
        activityForecast.clearErrors()

        populateValidParams(params)
        params.id = activityForecast.id
        params.version = -1
        controller.update()

        assert view == "/activityForecast/edit"
        assert model.activityForecastInstance != null
        assert model.activityForecastInstance.errors.getFieldError('version')
        assert flash.message != null
    }

    void testDelete() {
        controller.delete()
        assert flash.message != null
        assert response.redirectedUrl == '/activityForecast/list'

        response.reset()

        populateValidParams(params)
        def activityForecast = new ActivityForecast(params)

        assert activityForecast.save() != null
        assert ActivityForecast.count() == 1

        params.id = activityForecast.id

        controller.delete()

        assert ActivityForecast.count() == 0
        assert ActivityForecast.get(activityForecast.id) == null
        assert response.redirectedUrl == '/activityForecast/list'
    }
}
