package workloadforecast



import org.junit.*
import grails.test.mixin.*

@TestFor(CalendarController)
@Mock(Calendar)
class CalendarControllerTests {

    def populateValidParams(params) {
        assert params != null
        // TODO: Populate valid properties like...
        //params["name"] = 'someValidName'
    }

    void testIndex() {
        controller.index()
        assert "/calendar/list" == response.redirectedUrl
    }

    void testList() {

        def model = controller.list()

        assert model.calendarInstanceList.size() == 0
        assert model.calendarInstanceTotal == 0
    }

    void testCreate() {
        def model = controller.create()

        assert model.calendarInstance != null
    }

    void testSave() {
        controller.save()

        assert model.calendarInstance != null
        assert view == '/calendar/create'

        response.reset()

        populateValidParams(params)
        controller.save()

        assert response.redirectedUrl == '/calendar/show/1'
        assert controller.flash.message != null
        assert Calendar.count() == 1
    }

    void testShow() {
        controller.show()

        assert flash.message != null
        assert response.redirectedUrl == '/calendar/list'

        populateValidParams(params)
        def calendar = new Calendar(params)

        assert calendar.save() != null

        params.id = calendar.id

        def model = controller.show()

        assert model.calendarInstance == calendar
    }

    void testEdit() {
        controller.edit()

        assert flash.message != null
        assert response.redirectedUrl == '/calendar/list'

        populateValidParams(params)
        def calendar = new Calendar(params)

        assert calendar.save() != null

        params.id = calendar.id

        def model = controller.edit()

        assert model.calendarInstance == calendar
    }

    void testUpdate() {
        controller.update()

        assert flash.message != null
        assert response.redirectedUrl == '/calendar/list'

        response.reset()

        populateValidParams(params)
        def calendar = new Calendar(params)

        assert calendar.save() != null

        // test invalid parameters in update
        params.id = calendar.id
        //TODO: add invalid values to params object

        controller.update()

        assert view == "/calendar/edit"
        assert model.calendarInstance != null

        calendar.clearErrors()

        populateValidParams(params)
        controller.update()

        assert response.redirectedUrl == "/calendar/show/$calendar.id"
        assert flash.message != null

        //test outdated version number
        response.reset()
        calendar.clearErrors()

        populateValidParams(params)
        params.id = calendar.id
        params.version = -1
        controller.update()

        assert view == "/calendar/edit"
        assert model.calendarInstance != null
        assert model.calendarInstance.errors.getFieldError('version')
        assert flash.message != null
    }

    void testDelete() {
        controller.delete()
        assert flash.message != null
        assert response.redirectedUrl == '/calendar/list'

        response.reset()

        populateValidParams(params)
        def calendar = new Calendar(params)

        assert calendar.save() != null
        assert Calendar.count() == 1

        params.id = calendar.id

        controller.delete()

        assert Calendar.count() == 0
        assert Calendar.get(calendar.id) == null
        assert response.redirectedUrl == '/calendar/list'
    }
}
